/*
MetaPlab virtual laboratory
Copyright 2008 © Alberto Castellini

This file is part of MetaPlab.
MetaPlab is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MetaPlab is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MetaPlab.  If not, see <http://www.gnu.org/licenses/>.
*/

/*
 * MembraneMPExt.java
 *
 * Created on 17 dicembre 2007, 19.28
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package MPStoreExt;

import java.util.*;

/**
 *
 * @author Castellini
 */
public class MembraneMPExt implements Cloneable{
    
    public String name;
    public Vector<SubstanceExt> substanceList;  // Overriding
    public Vector<ParameterExt> parameterList;
    public Vector<FluxExt> fluxList;            // Overriding
    public Vector<ReactionExt> reactionList;
    
    /** Creates a new instance of MembraneMPExt */
    public MembraneMPExt(String membraneName, Vector<SubstanceExt> membraneSubstanceList,Vector<ParameterExt> membraneParameterList,Vector<FluxExt> membraneFluxList,Vector<ReactionExt> membraneReactionList) {
        name=membraneName;
        substanceList=membraneSubstanceList;
        parameterList=membraneParameterList;
        fluxList=membraneFluxList;
        reactionList=membraneReactionList;
    }
    
    public MembraneMPExt clone(){
        Vector<SubstanceExt> clonedSubList = new Vector<SubstanceExt>();
        for (int i = 0; i < substanceList.size(); i++)
            clonedSubList.add(substanceList.get(i).clone());  //to force the clonation of each SubstanceExt object
        Vector<ParameterExt> clonedParList = new Vector<ParameterExt>();
        for (int i = 0; i < parameterList.size(); i++)
            clonedParList.add(parameterList.get(i).clone());  //to force the clonation of each ParameterExt object
        Vector<FluxExt> clonedFluxList = new Vector<FluxExt>();
        for (int i = 0; i < fluxList.size(); i++)
            clonedFluxList.add(fluxList.get(i).clone());  //to force the clonation of each FluxExt object
        Vector<ReactionExt> clonedReactionList = new Vector<ReactionExt>();
        for (int i = 0; i < reactionList.size(); i++)
            clonedReactionList.add(reactionList.get(i).clone(clonedFluxList));  //to force the clonation of each ReactionExt object
        MembraneMPExt mmp=new MembraneMPExt(new String(name),clonedSubList,clonedParList,clonedFluxList,clonedReactionList);
        return(mmp);
    }
    
}
