/*
MetaPlab virtual laboratory
Copyright 2008 © Alberto Castellini, Luca Marchetti

This file is part of MetaPlab.
MetaPlab is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MetaPlab is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MetaPlab.  If not, see <http://www.gnu.org/licenses/>.
*/

package MPStoreExt;

/*
 * Variable.java
 *
 * Created on 22 febbraio 2007, 15.37
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author Petterlini
 */

// --- Code modified by Luca Marchetti        

// Since Regulator and Variable have different meaning but same data structures I've built this
// common class and extended it with Regulator class and Variable class.

public class ParameterExt {
    
    public String name;
    public String varName;
    public String evolution;
    public double[] values;
    public String extra;
    public boolean functional;  // functional parameter type
    public boolean periodical;  // periodical "by value" parameter
    
    // values parameter polymorphic constructor
    public ParameterExt(String paramName,String paramVarName,String paramEvolution, double[] paramValue, boolean paramFunctional, boolean paramPeriodical,String paramExtra){
        name=paramName;
        varName=paramVarName;
        evolution=paramEvolution;
        values=paramValue;
        extra=paramExtra;
        functional=paramFunctional; // values parameter type
        periodical=paramPeriodical;
    }
    
    public String toString(){
        if (functional)
            return(name+"|"+varName+"|"+evolution+"|"+values[0]+"|"+extra+"|functional");
        else
            return(name+"|"+varName+"|"+"|"+extra+"|defined by values");
    }

    public ParameterExt clone() {
        return new ParameterExt(new String(name), new String(varName), new String(evolution), values.clone(), functional, periodical, new String(extra));
    }
}
