/*
MetaPlab virtual laboratory
Copyright 2008 © Alberto Castellini, Luca Marchetti

This file is part of MetaPlab.
MetaPlab is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MetaPlab is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MetaPlab.  If not, see <http://www.gnu.org/licenses/>.
*/

/*
 * ReactionExt.java
 *
 * Created on 19 dicembre 2007, 16.12
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package MPStoreExt;
import java.util.*;

/**
 *
 * @author Castellini
 */
public class ReactionExt {
    
    public String name;
    public Vector<MultiplicityExt> reactants;
    public Vector<MultiplicityExt> products;
    public FluxExt reactiveUnit;
    
    /** Creates a new instance of ReactionExt */
    public ReactionExt(String reactionName,Vector<MultiplicityExt> reactionReactantList,Vector<MultiplicityExt> reactionProductList,FluxExt reactionUnit) {
        name=reactionName;
        reactants=reactionReactantList;
        products=reactionProductList;
        reactiveUnit=reactionUnit;
    }

    public ReactionExt clone() {
        System.err.println("Invalid clone call");
        return null;
    }

    public ReactionExt clone(Vector<FluxExt> clonedFluxList) {
        Vector<MultiplicityExt> clonedReactants = new Vector<MultiplicityExt>();
        for (int i = 0; i < reactants.size(); i++)
            clonedReactants.add(reactants.get(i).clone());  //to force the clonation of each MultiplicityExt object
        Vector<MultiplicityExt> clonedProducts = new Vector<MultiplicityExt>();
        for (int i = 0; i < products.size(); i++)
            clonedProducts.add(products.get(i).clone());  //to force the clonation of each MultiplicityExt object
        FluxExt newReactiveUnit=null;
        for (int i = 0; i < clonedFluxList.size(); i++){
            if(clonedFluxList.get(i).name.equals(reactiveUnit.name)){
                newReactiveUnit=clonedFluxList.get(i);
                break;
            }
        }
        return new ReactionExt(new String(name), (Vector<MultiplicityExt>)reactants.clone(), (Vector<MultiplicityExt>)products.clone(), newReactiveUnit);
    }
}
